﻿// Author: Orlys
// Github: https://github.com/Orlys

namespace Yuuna.TextSegmention
{
    using JiebaNet.Segmenter;

    using System;
    using System.Collections.Immutable;
    using System.Globalization;

    using Yuuna.Contracts.Semantics;
    using Yuuna.Contracts.TextSegmention;

    public sealed class JiebaTextSegmenter : ITextSegmenter
    {
        private readonly JiebaSegmenter _jieba = new JiebaSegmenter();

        public CultureInfo Culture => CultureInfo.GetCultureInfo("zh-TW");
        string ITextSegmenter.Name => "Jieba.Net";

        public IImmutableList<string> Cut(string text) => this._jieba.Cut(text, true, true).ToImmutableArray();

        public void Load(IGroupManager manager)
        {
            if (manager == null)
                return;

            foreach (var name in manager.Keys)
            {
                this.InternalLog("name: " + name);
                foreach (var synonym in manager[name].ToImmutable())
                {
                    this.InternalLog("  count: " + synonym.ToImmutable().Count);
                    foreach (var w in synonym.ToImmutable())
                    {
                        this.InternalLog("  added: " + w);
                        this._jieba.AddWord(w);
                    }
                }
                Console.WriteLine();
            }
        }

        private void InternalLog(string v)
        {
            Console.WriteLine(v);
        }
    }
}