﻿// Author: Orlys
// Github: https://github.com/Orlys

namespace Yuuna
{
    using System;
    using System.Collections.Generic;
    using System.Collections.Immutable;
    using System.Linq;
    using System.Text;

    using TestPlugin;

    using Yuuna.Contracts.Optimization;
    using Yuuna.Contracts.Plugins;
    using Yuuna.Contracts.TextSegmention;
    using Yuuna.Recognition.Speech;
    using Yuuna.Semantics;
    using Yuuna.TextSegmention;
    using Yuuna.Common.Utilities;
    using System.Threading.Tasks;

    internal class EntryPoint
    {
        public static void Main(string[] args)
        {

            Send("打開門");

            return;
            // Send("打開門"); Send("開燈");
            try
            {
                var stt = SpeechRecognizer.Create("secret.json");
                stt.RecognizeCompleted += a =>
                {
                    if (a.Count > 0)
                    {
                        Console.WriteLine("## Google 語音: " + a[0].Transcript);
                        Send(a[0].Transcript);
                    }
                };

                Console.WriteLine("## Proof of Concept Ver.");
                Console.WriteLine("可以叫我開關燈或者開關門，其他的我還不會");

                Console.WriteLine("按下 Enter 鍵開始錄音，任意鍵離開");
                Loop:
                if(Console.ReadKey().Key == ConsoleKey.Enter)
                { 
                    using (stt.Recognize())
                    {
                        Console.WriteLine("按下 Enter 停止錄音，任意鍵離開"); 
                        if(Console.ReadKey().Key == ConsoleKey.Enter)
                            goto Loop;
                    }
                } 
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.ReadKey();
            } 
        }

        public static void Send(string text)
        {
            var segmenter = new JiebaTextSegmenter() as ITextSegmenter;
            var allPlugins = new PluginBase[] { new Fake() };
            foreach (var item in allPlugins)
            {
                item.Initialize(segmenter, new GroupManager());
                Console.WriteLine("已載入模組: " + item.GetType().AssemblyQualifiedName);
            }

            Console.WriteLine("我: " + text);
            var cutted = segmenter.Cut(text);
            Console.WriteLine($"來自分詞器 {segmenter.Name} 的分詞結果: [ {string.Join(", ", cutted)} ]");

            IStrategy plan = new DefaultStrategy();
            var m = plan.FindBest(allPlugins, cutted);
            if (m.HasValue)
            {
                var match = m.Value;
                var pattern = match.Pattern;
                if (pattern.Owner.Patterns.TryGet(pattern, out var bag))
                {
                    if (match.IsExactMatch)
                    {
                        Console.WriteLine(bag.Invoke(match));
                    }                    
                    else
                    {
                        Console.WriteLine();
                    }
                }
                else
                    throw new Exception("未知的錯誤");
            }
            else
                Console.WriteLine("沒有任何模組相符");


            //var list = new List<IScore>();
            //foreach (var p in allPlugins)
            //    list.AddRange(p.Evaluate(cutted));
            //list.Sort(ScoreComparer.Default);

            //var sb = new StringBuilder("Bot: ");
            //var best = list.LastOrDefault();
            //if (best is null)
            //    sb.Append("我不懂你的意思");
            //else if (best.IsCompacted)
            //{
            //    var resp = best.Owner.SelectBest(best).Invoke(best);
            //    Console.WriteLine(resp.Mood.ToString());
            //    sb.Append(resp.Message);
            //}
            //else
            //{
            //    var choices = list.Where(s => s.Missing.Count <= 1).ToImmutableArray();
            //    switch (choices.Length)
            //    {
            //        case 1:
            //            {
            //                Console.WriteLine("#1");
            //                sb.Append("你" + new[] { "是想", "想要" }.RandomTakeOne() + " ");
            //                sb.Append(choices.Select(x => x.Pattern.ToImmutable().Aggregate(string.Empty, (s, g) => s += g.ToImmutable().RandomTakeOne().ToImmutable().RandomTakeOne())));
            //                sb.Append(" 嗎?");
            //            }
            //            break;

            //        case 2:
            //            {
            //                Console.WriteLine("#2");
            //                sb.Append("你" + new[] { "是想", "想要" }.RandomTakeOne() + " ");
            //                sb.AppendJoin(" 還是 ", choices.Select(x => x.Pattern.ToImmutable().Aggregate(string.Empty, (s, g) => s += g.ToImmutable().RandomTakeOne().ToImmutable().RandomTakeOne())));
            //                sb.Append(" ?");
            //            }
            //            break;

            //        default:
            //            Console.WriteLine("#n");
            //            sb.Append("我不太清楚你想做什麼");
            //            break;
            //    }
            //}

            //Console.WriteLine(sb);
        }
    }
}